﻿// *************************************
// "no warranty, use at your own risk
// but enjoy!  Hope it helps."
//                         -- jared
// jared@jaredficklin.com
// *************************************
// *************************************
// *************************************
/*
See the hello_world.fla for a sample use.

I really have paid little attention to optimization or garbage collection.  Please feel free to send suggestions if you see ways to improve.
*/
package com.frogdesign.utils{
	//
	import flash.utils.ByteArray;
	//
	public class frogDB{
		public function frogDB(ARRAY_TO_SET:Array=null,BYTE_ARRAY:ByteArray=null,NORMALIZE_VALUE:Number=1,IGNORE_ZERO:Boolean=false,DESCRIPTOR_STRING:String=""){
			/////////////////////////////
			var arSamples = new Array();
			var arDescribe = new Array();
			var arReturnValues = new Array();
			var i=0;
			//
			while (i<512) {
				//////////////////////////////////////////////////////////
				var a = BYTE_ARRAY.readFloat();// get the proper byte info
				//////////////////////////////////////////////////////////
				arSamples[i] = (a * NORMALIZE_VALUE) << 0;// normalize
				//
				i++
			}
			/////////////////////////////////////////////////////////////////////////
			/*
			Here is a great location to add your own dynamically built descriptor strings
			I have included some defaults already.  Sometimes it is faster than handwriting
			though that would be the most performant.
			//
			you can also store some handwritten ones here and give them your own CONSTANTS.
			Just add another case to the switch statement.
			//
			ALL is all 512 in one array.
			BUTTERFLY reverses the left channel so the low ends are 'center aligned'
			SWEET_SIXTEEN is a good 16 left 16 right eq.
			*/
			/////////////////////////////////////////////////////////////////////////
			switch(DESCRIPTOR_STRING){
				case "ALL":
					DESCRIPTOR_STRING = "";
					i=1;
					while(i<512){
						DESCRIPTOR_STRING += String(i) + "-" + String(i+1);
						if(++i<512) DESCRIPTOR_STRING += "|";
					};
				break;
				////////
				case "BUTTERFLY":
					DESCRIPTOR_STRING = "";
					i=256;
					while(i >= 1){
						DESCRIPTOR_STRING += String(i - 1) + "-" + String(i) + "|";
						i--;
					};
					//////
					i=257;
					while(i < 512){
						DESCRIPTOR_STRING += String(i) + "-" +  String(i+1);
						if(++i < 512) DESCRIPTOR_STRING += "|";
					};
				////////
				break;
				case "SWEET_SIXTEEN":
					DESCRIPTOR_STRING = "";
					var leftChannel = "1-10|5-15|10-20|15-25|20-30|25-35*1.1|30-40*1.1|35-45*1.1|40-50*1.1|45-55*1.2|50-60*1.2|55-65*1.2|60-70*1.2|65-75*1.3|70-80*1.4|75-85*1.5|80-256*3|";
					var rightChannel = "257-267|262-271|277-287|282-291|297-307|302-311*1.1|317-327*1.1|322-331*1.1|337-357*1.1|342-351*1.2|357-377*1.2|362-371*1.2|377-397*1.2|382-391*1.3|397-417*1.4|402-421*1.5|417-512*3";        
					DESCRIPTOR_STRING = leftChannel + rightChannel;
				break;
				////////
				default:
				break;
				
			}
			//
			//trace(DESCRIPTOR_STRING);
			//
			//////////////////////////////////////////
			// parse the descriptor string
			//////////////////////////////////////////
			arDescribe = DESCRIPTOR_STRING.split("|");
			var end:Number = arDescribe.length;
			var d:Number = 0;
			//////////////////////////////////////////
			while(d<end){
				////////////////////////////////////////////////
				var multiplier:Array = arDescribe[d].split("*");
				var segment = new Array();
				//////////////////////////
				if(multiplier[1] != null){
					//
					segment = multiplier[0].split("-");
					//
				} else {
					//
					segment = arDescribe[d].split("-");
					//
				}
				//////////////////
				var zeroCount = 0;
				var val = 0;
				///////////////////////////////////////////////////////////
				///////////////////////////////////////////////////////////
				for(var s = Number(segment[0]); s<Number(segment[1]); s++){
					 if(IGNORE_ZERO == true && arSamples[s] == 0){
						zeroCount++;
					} else {
						if(multiplier[1] != null){
							val += (arSamples[s] * multiplier[1]);
						} else{
							val += arSamples[s];
						}
					}
				}
				///////////////////////////////////////////////////////////
				///////////////////////////////////////////////////////////
				var divisor:Number = segment[1]-segment[0]-zeroCount;
				divisor = (divisor <=0)?1:divisor;
				////////////////////////////////
				// populate the array to set
				////////////////////////////////
				ARRAY_TO_SET.push(val/divisor);
				//
				d++;
			}
		}		
	}	
}